import{s as Oe,n as ke,o as Ce}from"../chunks/scheduler.182ea377.js";import{S as Ne,i as Ae,g as r,s as i,p as S,A as Le,h as n,f as o,c as d,j as l,q as I,m as C,k as s,v as t,a as m,r as q,d as H,t as F,u as U}from"../chunks/index.008d68e4.js";import{D as me}from"../chunks/Docstring.7aec8b85.js";import{I as fe}from"../chunks/IconCopyLink.96bbb92b.js";function Pe(ce){let c,J,p,g,j,w,re,N,pe="Transformer Temporal",R,x,ue="A Transformer model for video-like data.",W,u,T,B,$,ne,A,he="TransformerTemporalModel",Z,f,M,se,L,_e="A Transformer model for video-like data.",ae,v,y,ie,P,ge="The <code>TransformerTemporal</code> forward method.",G,h,b,V,O,de,E,Te="TransformerTemporalModelOutput",K,_,k,le,z,ve="The output of <code>TransformerTemporalModel</code>.",Q;return w=new fe({}),$=new fe({}),M=new me({props:{name:"class diffusers.models.TransformerTemporalModel",anchor:"diffusers.models.TransformerTemporalModel",parameters:[{name:"num_attention_heads",val:": int = 16"},{name:"attention_head_dim",val:": int = 88"},{name:"in_channels",val:": Optional = None"},{name:"out_channels",val:": Optional = None"},{name:"num_layers",val:": int = 1"},{name:"dropout",val:": float = 0.0"},{name:"norm_num_groups",val:": int = 32"},{name:"cross_attention_dim",val:": Optional = None"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": Optional = None"},{name:"activation_fn",val:": str = 'geglu'"},{name:"norm_elementwise_affine",val:": bool = True"},{name:"double_self_attention",val:": bool = True"},{name:"positional_embeddings",val:": Optional = None"},{name:"num_positional_embeddings",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.models.TransformerTemporalModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.models.TransformerTemporalModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 88) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.models.TransformerTemporalModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of channels in the input and output (specify if the input is <strong>continuous</strong>).`,name:"in_channels"},{anchor:"diffusers.models.TransformerTemporalModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.models.TransformerTemporalModel.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"},{anchor:"diffusers.models.TransformerTemporalModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of <code>encoder_hidden_states</code> dimensions to use.",name:"cross_attention_dim"},{anchor:"diffusers.models.TransformerTemporalModel.attention_bias",description:`<strong>attention_bias</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the <code>TransformerBlock</code> attention should contain a bias parameter.`,name:"attention_bias"},{anchor:"diffusers.models.TransformerTemporalModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; The width of the latent images (specify if the input is <strong>discrete</strong>).
This is fixed during training since it is used to learn a number of position embeddings.`,name:"sample_size"},{anchor:"diffusers.models.TransformerTemporalModel.activation_fn",description:`<strong>activation_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;geglu&quot;</code>) &#x2014;
Activation function to use in feed-forward. See <code>diffusers.models.activations.get_activation</code> for supported
activation functions.`,name:"activation_fn"},{anchor:"diffusers.models.TransformerTemporalModel.norm_elementwise_affine",description:`<strong>norm_elementwise_affine</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the <code>TransformerBlock</code> should use learnable elementwise affine parameters for normalization.`,name:"norm_elementwise_affine"},{anchor:"diffusers.models.TransformerTemporalModel.double_self_attention",description:`<strong>double_self_attention</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if each <code>TransformerBlock</code> should contain two self-attention layers.
positional_embeddings &#x2014; (<code>str</code>, <em>optional</em>):
The type of positional embeddings to apply to the sequence input before passing use.
num_positional_embeddings &#x2014; (<code>int</code>, <em>optional</em>):
The maximum length of the sequence over which to apply positional embeddings.`,name:"double_self_attention"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/transformer_temporal.py#L41"}}),y=new me({props:{name:"forward",anchor:"diffusers.models.TransformerTemporalModel.forward",parameters:[{name:"hidden_states",val:": FloatTensor"},{name:"encoder_hidden_states",val:": Optional = None"},{name:"timestep",val:": Optional = None"},{name:"class_labels",val:": LongTensor = None"},{name:"num_frames",val:": int = 1"},{name:"cross_attention_kwargs",val:": Optional = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.TransformerTemporalModel.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.LongTensor</code> of shape <code>(batch size, num latent pixels)</code> if discrete, <code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code> if continuous) &#x2014;
Input hidden_states.`,name:"hidden_states"},{anchor:"diffusers.models.TransformerTemporalModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, encoder_hidden_states dim)</code>, <em>optional</em>) &#x2014;
Conditional embeddings for cross attention layer. If not given, cross-attention defaults to
self-attention.`,name:"encoder_hidden_states"},{anchor:"diffusers.models.TransformerTemporalModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.LongTensor</code>, <em>optional</em>) &#x2014;
Used to indicate denoising step. Optional timestep to be applied as an embedding in <code>AdaLayerNorm</code>.`,name:"timestep"},{anchor:"diffusers.models.TransformerTemporalModel.forward.class_labels",description:`<strong>class_labels</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, num classes)</code>, <em>optional</em>) &#x2014;
Used to indicate class labels conditioning. Optional class labels to be applied as an embedding in
<code>AdaLayerZeroNorm</code>.`,name:"class_labels"},{anchor:"diffusers.models.TransformerTemporalModel.forward.num_frames",description:`<strong>num_frames</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of frames to be processed per batch. This is used to reshape the hidden states.`,name:"num_frames"},{anchor:"diffusers.models.TransformerTemporalModel.forward.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/attention_processor.py" rel="nofollow">diffusers.models.attention_processor</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.models.TransformerTemporalModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.25.0/en/api/models/unet2d-cond#diffusers.models.unet_2d_condition.UNet2DConditionOutput">UNet2DConditionOutput</a> instead of a plain
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/transformer_temporal.py#L121",returnDescription:`
<p>If <code>return_dict</code> is True, an <a
  href="/docs/diffusers/v0.25.0/en/api/models/transformer_temporal#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"
>TransformerTemporalModelOutput</a> is
returned, otherwise a <code>tuple</code> where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/v0.25.0/en/api/models/transformer_temporal#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"
>TransformerTemporalModelOutput</a> or <code>tuple</code></p>
`}}),O=new fe({}),k=new me({props:{name:"class diffusers.models.transformer_temporal.TransformerTemporalModelOutput",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size x num_frames, num_channels, height, width)</code>) &#x2014;
The hidden states output conditioned on <code>encoder_hidden_states</code> input.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/transformer_temporal.py#L28"}}),{c(){c=r("meta"),J=i(),p=r("h1"),g=r("a"),j=r("span"),S(w.$$.fragment),re=i(),N=r("span"),N.textContent=pe,R=i(),x=r("p"),x.textContent=ue,W=i(),u=r("h2"),T=r("a"),B=r("span"),S($.$$.fragment),ne=i(),A=r("span"),A.textContent=he,Z=i(),f=r("div"),S(M.$$.fragment),se=i(),L=r("p"),L.textContent=_e,ae=i(),v=r("div"),S(y.$$.fragment),ie=i(),P=r("p"),P.innerHTML=ge,G=i(),h=r("h2"),b=r("a"),V=r("span"),S(O.$$.fragment),de=i(),E=r("span"),E.textContent=Te,K=i(),_=r("div"),S(k.$$.fragment),le=i(),z=r("p"),z.innerHTML=ve,this.h()},l(e){const a=Le("svelte-1phssyn",document.head);c=n(a,"META",{name:!0,content:!0}),a.forEach(o),J=d(e),p=n(e,"H1",{class:!0});var X=l(p);g=n(X,"A",{id:!0,class:!0,href:!0});var be=l(g);j=n(be,"SPAN",{});var we=l(j);I(w.$$.fragment,we),we.forEach(o),be.forEach(o),re=d(X),N=n(X,"SPAN",{"data-svelte-h":!0}),C(N)!=="svelte-11vag4o"&&(N.textContent=pe),X.forEach(o),R=d(e),x=n(e,"P",{"data-svelte-h":!0}),C(x)!=="svelte-1ywwpi7"&&(x.textContent=ue),W=d(e),u=n(e,"H2",{class:!0});var Y=l(u);T=n(Y,"A",{id:!0,class:!0,href:!0});var xe=l(T);B=n(xe,"SPAN",{});var $e=l(B);I($.$$.fragment,$e),$e.forEach(o),xe.forEach(o),ne=d(Y),A=n(Y,"SPAN",{"data-svelte-h":!0}),C(A)!=="svelte-7exteb"&&(A.textContent=he),Y.forEach(o),Z=d(e),f=n(e,"DIV",{class:!0});var D=l(f);I(M.$$.fragment,D),se=d(D),L=n(D,"P",{"data-svelte-h":!0}),C(L)!=="svelte-1ywwpi7"&&(L.textContent=_e),ae=d(D),v=n(D,"DIV",{class:!0});var ee=l(v);I(y.$$.fragment,ee),ie=d(ee),P=n(ee,"P",{"data-svelte-h":!0}),C(P)!=="svelte-14zjqkb"&&(P.innerHTML=ge),ee.forEach(o),D.forEach(o),G=d(e),h=n(e,"H2",{class:!0});var oe=l(h);b=n(oe,"A",{id:!0,class:!0,href:!0});var Me=l(b);V=n(Me,"SPAN",{});var ye=l(V);I(O.$$.fragment,ye),ye.forEach(o),Me.forEach(o),de=d(oe),E=n(oe,"SPAN",{"data-svelte-h":!0}),C(E)!=="svelte-cb8pjk"&&(E.textContent=Te),oe.forEach(o),K=d(e),_=n(e,"DIV",{class:!0});var te=l(_);I(k.$$.fragment,te),le=d(te),z=n(te,"P",{"data-svelte-h":!0}),C(z)!=="svelte-1wdi1wk"&&(z.innerHTML=ve),te.forEach(o),this.h()},h(){s(c,"name","hf:doc:metadata"),s(c,"content",JSON.stringify(Ee)),s(g,"id","transformer-temporal"),s(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(g,"href","#transformer-temporal"),s(p,"class","relative group"),s(T,"id","diffusers.models.TransformerTemporalModel"),s(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(T,"href","#diffusers.models.TransformerTemporalModel"),s(u,"class","relative group"),s(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(b,"id","diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),s(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(b,"href","#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),s(h,"class","relative group"),s(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){t(document.head,c),m(e,J,a),m(e,p,a),t(p,g),t(g,j),q(w,j,null),t(p,re),t(p,N),m(e,R,a),m(e,x,a),m(e,W,a),m(e,u,a),t(u,T),t(T,B),q($,B,null),t(u,ne),t(u,A),m(e,Z,a),m(e,f,a),q(M,f,null),t(f,se),t(f,L),t(f,ae),t(f,v),q(y,v,null),t(v,ie),t(v,P),m(e,G,a),m(e,h,a),t(h,b),t(b,V),q(O,V,null),t(h,de),t(h,E),m(e,K,a),m(e,_,a),q(k,_,null),t(_,le),t(_,z),Q=!0},p:ke,i(e){Q||(H(w.$$.fragment,e),H($.$$.fragment,e),H(M.$$.fragment,e),H(y.$$.fragment,e),H(O.$$.fragment,e),H(k.$$.fragment,e),Q=!0)},o(e){F(w.$$.fragment,e),F($.$$.fragment,e),F(M.$$.fragment,e),F(y.$$.fragment,e),F(O.$$.fragment,e),F(k.$$.fragment,e),Q=!1},d(e){e&&(o(J),o(p),o(R),o(x),o(W),o(u),o(Z),o(f),o(G),o(h),o(K),o(_)),o(c),U(w),U($),U(M),U(y),U(O),U(k)}}}const Ee={local:"transformer-temporal",sections:[{local:"diffusers.models.TransformerTemporalModel",title:"TransformerTemporalModel"},{local:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",title:"TransformerTemporalModelOutput"}],title:"Transformer Temporal"};function ze(ce){return Ce(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class He extends Ne{constructor(c){super(),Ae(this,c,ze,Pe,Oe,{})}}export{He as component};
