import{s as je,n as Ke,o as Be}from"../chunks/scheduler.182ea377.js";import{S as Re,i as We,g as r,s as i,p as y,A as Ge,h as n,f as s,c as a,j as l,q as H,m as h,k as o,v as t,a as p,r as T,d as C,t as k,u as P}from"../chunks/index.008d68e4.js";import{D as X}from"../chunks/Docstring.7aec8b85.js";import{I as ye}from"../chunks/IconCopyLink.96bbb92b.js";function Je(He){let f,Z,m,b,J,E,he,U,Te="HeunDiscreteScheduler",ee,O,Ce='The Heun scheduler (Algorithm 1) is from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper by Karras et al. The scheduler is ported from the <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">k-diffusion</a> library and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',te,g,$,Y,A,fe,V,ke="HeunDiscreteScheduler",se,d,L,me,z,Pe="Scheduler with Heun steps for discrete beta schedules.",ge,j,Ee=`This model inherits from <a href="/docs/diffusers/v0.25.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.25.0/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,_e,x,M,ve,K,Oe=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,be,S,F,$e,B,Ae="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",xe,D,N,Se,R,Le=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,re,_,w,Q,q,De,W,Me="SchedulerOutput",ne,v,I,we,G,Fe="Base class for the output of a scheduler’s <code>step</code> function.",oe;return E=new ye({}),A=new ye({}),L=new X({props:{name:"class diffusers.HeunDiscreteScheduler",anchor:"diffusers.HeunDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"clip_sample",val:": Optional = False"},{name:"clip_sample_range",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.HeunDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.HeunDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.HeunDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.HeunDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.HeunDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.HeunDiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.HeunDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.HeunDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps. You can use a combination of <code>offset=1</code> and
<code>set_alpha_to_one=False</code> to make the last step use step 0 for the previous alpha product like in Stable
Diffusion.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L71"}}),M=new X({props:{name:"scale_model_input",anchor:"diffusers.HeunDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L186",returnDescription:`
<p>A scaled input sample.</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),F=new X({props:{name:"set_timesteps",anchor:"diffusers.HeunDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L212"}}),N=new X({props:{name:"step",anchor:"diffusers.HeunDiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.HeunDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.HeunDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.25.0/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_heun_discrete.py#L352",returnDescription:`
<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/v0.25.0/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/v0.25.0/en/api/schedulers/singlestep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),q=new ye({}),I=new X({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/schedulers/scheduling_utils.py#L50"}}),{c(){f=r("meta"),Z=i(),m=r("h1"),b=r("a"),J=r("span"),y(E.$$.fragment),he=i(),U=r("span"),U.textContent=Te,ee=i(),O=r("p"),O.innerHTML=Ce,te=i(),g=r("h2"),$=r("a"),Y=r("span"),y(A.$$.fragment),fe=i(),V=r("span"),V.textContent=ke,se=i(),d=r("div"),y(L.$$.fragment),me=i(),z=r("p"),z.textContent=Pe,ge=i(),j=r("p"),j.innerHTML=Ee,_e=i(),x=r("div"),y(M.$$.fragment),ve=i(),K=r("p"),K.textContent=Oe,be=i(),S=r("div"),y(F.$$.fragment),$e=i(),B=r("p"),B.textContent=Ae,xe=i(),D=r("div"),y(N.$$.fragment),Se=i(),R=r("p"),R.textContent=Le,re=i(),_=r("h2"),w=r("a"),Q=r("span"),y(q.$$.fragment),De=i(),W=r("span"),W.textContent=Me,ne=i(),v=r("div"),y(I.$$.fragment),we=i(),G=r("p"),G.innerHTML=Fe,this.h()},l(e){const c=Ge("svelte-1phssyn",document.head);f=n(c,"META",{name:!0,content:!0}),c.forEach(s),Z=a(e),m=n(e,"H1",{class:!0});var ie=l(m);b=n(ie,"A",{id:!0,class:!0,href:!0});var Ne=l(b);J=n(Ne,"SPAN",{});var qe=l(J);H(E.$$.fragment,qe),qe.forEach(s),Ne.forEach(s),he=a(ie),U=n(ie,"SPAN",{"data-svelte-h":!0}),h(U)!=="svelte-19psgdn"&&(U.textContent=Te),ie.forEach(s),ee=a(e),O=n(e,"P",{"data-svelte-h":!0}),h(O)!=="svelte-1r9m54f"&&(O.innerHTML=Ce),te=a(e),g=n(e,"H2",{class:!0});var ae=l(g);$=n(ae,"A",{id:!0,class:!0,href:!0});var Ie=l($);Y=n(Ie,"SPAN",{});var Ue=l(Y);H(A.$$.fragment,Ue),Ue.forEach(s),Ie.forEach(s),fe=a(ae),V=n(ae,"SPAN",{"data-svelte-h":!0}),h(V)!=="svelte-19psgdn"&&(V.textContent=ke),ae.forEach(s),se=a(e),d=n(e,"DIV",{class:!0});var u=l(d);H(L.$$.fragment,u),me=a(u),z=n(u,"P",{"data-svelte-h":!0}),h(z)!=="svelte-1k165jq"&&(z.textContent=Pe),ge=a(u),j=n(u,"P",{"data-svelte-h":!0}),h(j)!=="svelte-1coxf99"&&(j.innerHTML=Ee),_e=a(u),x=n(u,"DIV",{class:!0});var de=l(x);H(M.$$.fragment,de),ve=a(de),K=n(de,"P",{"data-svelte-h":!0}),h(K)!=="svelte-1rkfgpx"&&(K.textContent=Oe),de.forEach(s),be=a(u),S=n(u,"DIV",{class:!0});var ce=l(S);H(F.$$.fragment,ce),$e=a(ce),B=n(ce,"P",{"data-svelte-h":!0}),h(B)!=="svelte-1vzm9q"&&(B.textContent=Ae),ce.forEach(s),xe=a(u),D=n(u,"DIV",{class:!0});var le=l(D);H(N.$$.fragment,le),Se=a(le),R=n(le,"P",{"data-svelte-h":!0}),h(R)!=="svelte-hi84tp"&&(R.textContent=Le),le.forEach(s),u.forEach(s),re=a(e),_=n(e,"H2",{class:!0});var ue=l(_);w=n(ue,"A",{id:!0,class:!0,href:!0});var Ve=l(w);Q=n(Ve,"SPAN",{});var ze=l(Q);H(q.$$.fragment,ze),ze.forEach(s),Ve.forEach(s),De=a(ue),W=n(ue,"SPAN",{"data-svelte-h":!0}),h(W)!=="svelte-1qoi9nz"&&(W.textContent=Me),ue.forEach(s),ne=a(e),v=n(e,"DIV",{class:!0});var pe=l(v);H(I.$$.fragment,pe),we=a(pe),G=n(pe,"P",{"data-svelte-h":!0}),h(G)!=="svelte-6ojmkw"&&(G.innerHTML=Fe),pe.forEach(s),this.h()},h(){o(f,"name","hf:doc:metadata"),o(f,"content",JSON.stringify(Ye)),o(b,"id","heundiscretescheduler"),o(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(b,"href","#heundiscretescheduler"),o(m,"class","relative group"),o($,"id","diffusers.HeunDiscreteScheduler"),o($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o($,"href","#diffusers.HeunDiscreteScheduler"),o(g,"class","relative group"),o(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),o(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),o(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),o(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),o(w,"id","diffusers.schedulers.scheduling_utils.SchedulerOutput"),o(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(w,"href","#diffusers.schedulers.scheduling_utils.SchedulerOutput"),o(_,"class","relative group"),o(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,c){t(document.head,f),p(e,Z,c),p(e,m,c),t(m,b),t(b,J),T(E,J,null),t(m,he),t(m,U),p(e,ee,c),p(e,O,c),p(e,te,c),p(e,g,c),t(g,$),t($,Y),T(A,Y,null),t(g,fe),t(g,V),p(e,se,c),p(e,d,c),T(L,d,null),t(d,me),t(d,z),t(d,ge),t(d,j),t(d,_e),t(d,x),T(M,x,null),t(x,ve),t(x,K),t(d,be),t(d,S),T(F,S,null),t(S,$e),t(S,B),t(d,xe),t(d,D),T(N,D,null),t(D,Se),t(D,R),p(e,re,c),p(e,_,c),t(_,w),t(w,Q),T(q,Q,null),t(_,De),t(_,W),p(e,ne,c),p(e,v,c),T(I,v,null),t(v,we),t(v,G),oe=!0},p:Ke,i(e){oe||(C(E.$$.fragment,e),C(A.$$.fragment,e),C(L.$$.fragment,e),C(M.$$.fragment,e),C(F.$$.fragment,e),C(N.$$.fragment,e),C(q.$$.fragment,e),C(I.$$.fragment,e),oe=!0)},o(e){k(E.$$.fragment,e),k(A.$$.fragment,e),k(L.$$.fragment,e),k(M.$$.fragment,e),k(F.$$.fragment,e),k(N.$$.fragment,e),k(q.$$.fragment,e),k(I.$$.fragment,e),oe=!1},d(e){e&&(s(Z),s(m),s(ee),s(O),s(te),s(g),s(se),s(d),s(re),s(_),s(ne),s(v)),s(f),P(E),P(A),P(L),P(M),P(F),P(N),P(q),P(I)}}}const Ye={local:"heundiscretescheduler",sections:[{local:"diffusers.HeunDiscreteScheduler",title:"HeunDiscreteScheduler"},{local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",title:"SchedulerOutput"}],title:"HeunDiscreteScheduler"};function Qe(He){return Be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class st extends Re{constructor(f){super(),We(this,f,Qe,Je,je,{})}}export{st as component};
